Notes in EJ2 JavaScript Spreadsheet control

6 Jan 202524 minutes to read

The Notes feature is used to insert comments, provide feedback, suggest changes, or leave remarks on specific cells while reviewing documents in the Spreadsheet. You can enable or disable the notes functionality using the enableNotes property, which defaults to true.

When opening the Excel document with notes in the Spreadsheet, they will be displayed in the control. The cells containing notes will be indicated with a red colored triangle at the top-right corner. Hovering the mouse over these cells will display the content of the notes.

Spreadsheet showing a note

In the below example, you can add, edit, save, and delete notes.

var sheet = [
  {
    ranges: [
      {
        dataSource: [
          {
            'Item Name': 'Casual Shoes',
            Date: '02/14/2014',
            Time: '11:34:32 AM',
            Quantity: 10,
            Price: 20,
            Amount: 200,
            Discount: 1,
            Profit: 10,
          },
          {
            'Item Name': 'Sports Shoes',
            Date: '06/11/2014',
            Time: '05:56:32 AM',
            Quantity: 20,
            Price: 30,
            Amount: 600,
            Discount: 5,
            Profit: 50,
          },
          {
            'Item Name': 'Formal Shoes',
            Date: '07/27/2014',
            Time: '03:32:44 AM',
            Quantity: 20,
            Price: 15,
            Amount: 300,
            Discount: 7,
            Profit: 27,
          },
          {
            'Item Name': 'Sandals & Floaters',
            Date: '11/21/2014',
            Time: '06:23:54 AM',
            Quantity: 15,
            Price: 20,
            Amount: 300,
            Discount: 11,
            Profit: 67,
          },
          {
            'Item Name': 'Flip- Flops & Slippers',
            Date: '06/23/2014',
            Time: '12:43:59 AM',
            Quantity: 30,
            Price: 10,
            Amount: 300,
            Discount: 10,
            Profit: 70,
          },
          {
            'Item Name': 'Sneakers',
            Date: '07/22/2014',
            Time: '10:55:53 AM',
            Quantity: 40,
            Price: 20,
            Amount: 800,
            Discount: 13,
            Profit: 66,
          },
          {
            'Item Name': 'Running Shoes',
            Date: '02/04/2014',
            Time: '03:44:34 AM',
            Quantity: 20,
            Price: 10,
            Amount: 200,
            Discount: 3,
            Profit: 14,
          },
          {
            'Item Name': 'Loafers',
            Date: '11/30/2014',
            Time: '03:12:52 AM',
            Quantity: 31,
            Price: 10,
            Amount: 310,
            Discount: 6,
            Profit: 29,
          },
          {
            'Item Name': 'Cricket Shoes',
            Date: '07/09/2014',
            Time: '11:32:14 AM',
            Quantity: 41,
            Price: 30,
            Amount: 1210,
            Discount: 12,
            Profit: 166,
          },
          {
            'Item Name': 'T-Shirts',
            Date: '10/31/2014',
            Time: '12:01:44 AM',
            Quantity: 50,
            Price: 10,
            Amount: 500,
            Discount: 9,
            Profit: 55,
          },
        ],
        startCell: 'A1',
      },
    ],
    rowCount: 200,
    columns: [
      {
        width: 130,
      },
      {
        width: 92,
      },
      {
        width: 96,
      },
    ],
  },
];
var spreadsheet = new ej.spreadsheet.Spreadsheet({
    sheets: sheet,
    allowOpen: true,
    openUrl: 'https://services.syncfusion.com/js/production/api/spreadsheet/open',
    allowSave: true,
    saveUrl: 'https://services.syncfusion.com/js/production/api/spreadsheet/save',
    created: function () {
      spreadsheet.cellFormat({ fontWeight: 'bold' }, 'A1:H1');
    }
});
spreadsheet.appendTo('#spreadsheet');
<!DOCTYPE html>
<html lang="en">

<head>
  <title>EJ2 SpreadSheet</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="description" content="Typescript UI Controls">
  <meta name="author" content="Syncfusion">
  <link rel="shortcut icon" href="resources/favicon.ico">
  <link href="https://cdn.syncfusion.com/ej2/29.1.33/material.css" rel="stylesheet" />
  <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-grids/styles/material.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-spreadsheet/styles/material.css" rel="stylesheet">
  <link href="styles.css" rel="stylesheet">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/core-js/2.4.1/shim.min.js"></script>
  <script src="https://cdn.syncfusion.com/ej2/29.1.33/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
  <div id="container">
    <div id="spreadsheet"></div>
  </div>
  <script>
    var ele = document.getElementById('container');
    if (ele) {
      ele.style.visibility = "visible";
    }   
  </script>
  <script src="index.js" type="text/javascript"></script>
</body>

</html>

Adding a note

In the active worksheet, you can add a note in the following ways:

  • To add a note, right-click the cell to open the context menu and choose the “Add Note” option from the context menu. This will open a dialog box to add the content as a note.
  • You can also use the Shift + F2 keyboard shortcut to add a note to the desired cell. A dialog box will be opened to add the content as a note.
  • After entering the content in the dialog box, you can either click on other cells or press the Esc button on the keyboard to automatically save the note in the cell and close the dialog box.

Adding a note in Spreadsheet

Editing a note

In the active worksheet, you can modify the content of existing notes in the document.

  • To edit a note, right-click on the desired cell containing the note, which will open the context menu.
  • Select the “Edit Note” option from the context menu.
  • You can also use the Shift + F2 keyboard shortcut to edit the note of the desired cell. A dialog box will be opened to edit the note.
  • After editing the content in the dialog box, you can either click on other cells or press the Esc button on the keyboard to automatically save the note in the cell and close the dialog box.

Editing a note in Spreadsheet

Deleting a note

In the active worksheet, right-click on the desired cell containing the note that you want to remove, which opens the context menu. In the context menu, select the “Delete Note” option to delete the note.

Deleting a note in Spreadsheet

Saving the document with notes

The Spreadsheet data, including notes, can be saved and exported as an Excel document by selecting File > Save As in the ribbon menu. Exporting worksheets with notes is supported in Excel file formats such as MS Excel (.xlsx) and MS Excel 97-2003 (.xls).

When exporting the Spreadsheet to file formats such as Comma Separated Values (.csv), Excel Macro-Enabled Workbook (.xlsm), Excel Binary Workbook (.xlsb), and PDF Document (.pdf), the notes will not be available.

Disabling notes

To disable the note functionality, you need to set the enableNotes property to false. After disabling, the notes in the document will not be shown when opened in the Spreadsheet. The “Add Note” option will not be shown in the context menu. The keyboard shortcuts for the note functionality will not work.

Spreadsheet with notes feature disabled

In the below example, the note functionality is disabled in the Spreadsheet.

var sheet = [
  {
    ranges: [
      {
        dataSource: [
          {
            'Item Name': 'Casual Shoes',
            Date: '02/14/2014',
            Time: '11:34:32 AM',
            Quantity: 10,
            Price: 20,
            Amount: 200,
            Discount: 1,
            Profit: 10,
          },
          {
            'Item Name': 'Sports Shoes',
            Date: '06/11/2014',
            Time: '05:56:32 AM',
            Quantity: 20,
            Price: 30,
            Amount: 600,
            Discount: 5,
            Profit: 50,
          },
          {
            'Item Name': 'Formal Shoes',
            Date: '07/27/2014',
            Time: '03:32:44 AM',
            Quantity: 20,
            Price: 15,
            Amount: 300,
            Discount: 7,
            Profit: 27,
          },
          {
            'Item Name': 'Sandals & Floaters',
            Date: '11/21/2014',
            Time: '06:23:54 AM',
            Quantity: 15,
            Price: 20,
            Amount: 300,
            Discount: 11,
            Profit: 67,
          },
          {
            'Item Name': 'Flip- Flops & Slippers',
            Date: '06/23/2014',
            Time: '12:43:59 AM',
            Quantity: 30,
            Price: 10,
            Amount: 300,
            Discount: 10,
            Profit: 70,
          },
          {
            'Item Name': 'Sneakers',
            Date: '07/22/2014',
            Time: '10:55:53 AM',
            Quantity: 40,
            Price: 20,
            Amount: 800,
            Discount: 13,
            Profit: 66,
          },
          {
            'Item Name': 'Running Shoes',
            Date: '02/04/2014',
            Time: '03:44:34 AM',
            Quantity: 20,
            Price: 10,
            Amount: 200,
            Discount: 3,
            Profit: 14,
          },
          {
            'Item Name': 'Loafers',
            Date: '11/30/2014',
            Time: '03:12:52 AM',
            Quantity: 31,
            Price: 10,
            Amount: 310,
            Discount: 6,
            Profit: 29,
          },
          {
            'Item Name': 'Cricket Shoes',
            Date: '07/09/2014',
            Time: '11:32:14 AM',
            Quantity: 41,
            Price: 30,
            Amount: 1210,
            Discount: 12,
            Profit: 166,
          },
          {
            'Item Name': 'T-Shirts',
            Date: '10/31/2014',
            Time: '12:01:44 AM',
            Quantity: 50,
            Price: 10,
            Amount: 500,
            Discount: 9,
            Profit: 55,
          },
        ],
        startCell: 'A1',
      },
    ],
    rowCount: 200,
    columns: [
      {
        width: 130,
      },
      {
        width: 92,
      },
      {
        width: 96,
      },
    ],
  },
];
var spreadsheet = new ej.spreadsheet.Spreadsheet({
    sheets: sheet,
    enableNotes: false,
    allowOpen: true,
    openUrl: 'https://services.syncfusion.com/js/production/api/spreadsheet/open',
    allowSave: true,
    saveUrl: 'https://services.syncfusion.com/js/production/api/spreadsheet/save',
    created: function () {
      spreadsheet.cellFormat({ fontWeight: 'bold' }, 'A1:H1');
    }
});

spreadsheet.appendTo('#spreadsheet');
<!DOCTYPE html>
<html lang="en">

<head>
  <title>EJ2 SpreadSheet</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="description" content="Typescript UI Controls">
  <meta name="author" content="Syncfusion">
  <link rel="shortcut icon" href="resources/favicon.ico">
  <link href="https://cdn.syncfusion.com/ej2/29.1.33/material.css" rel="stylesheet" />
  <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-grids/styles/material.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-spreadsheet/styles/material.css" rel="stylesheet">
  <link href="styles.css" rel="stylesheet">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/core-js/2.4.1/shim.min.js"></script>
  <script src="https://cdn.syncfusion.com/ej2/29.1.33/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
  <div id="container">
    <div id="spreadsheet"></div>
  </div>
  <script>
    var ele = document.getElementById('container');
    if (ele) {
      ele.style.visibility = "visible";
    }   
  </script>
  <script src="index.js" type="text/javascript"></script>
</body>

</html>

Integrating notes during initial loading and using cell data binding

The notes can be added initially when the Spreadsheet loads using cell data binding. You need to use the notes property in the cell settings to add notes to the Spreadsheet.

var sheet = [
  {
    name: 'PriceDetails',
    rows: [
      {
        cells: [
          { value: 'Item Name' },
          { value: 'Stock Detail' },
          { value: 'Website' },
        ],
      },
      {
        cells: [
          { value: 'Casual Shoes' },
          { value: 'OUT OF STOCK' },
          { value: 'Amazon' },
        ],
      },
      {
        cells: [
          {
            value: 'Sports Shoes',
            notes:
              'These shoes have the highest sales in terms of quantity this month.',
          },
          { value: 'IN STOCK' },
          { value: 'Overstack' },
        ],
      },
      {
        cells: [
          { value: 'Formal Shoes' },
          { value: 'IN STOCK' },
          { value: 'AliExpress' },
        ],
      },
      {
        cells: [
          { value: 'Sandals & Floaters' },
          { value: 'OUT OF STOCK' },
          { value: 'AliBaba' },
        ],
      },
      {
        cells: [
          {
            value: 'Flip-Flops & Slippers',
            notes: 'These shoes have been the most profitable this month.',
          },
          { value: 'IN STOCK' },
          { value: 'Taobao' },
        ],
      },
    ],
    columns: [{ width: 160 }, { width: 160 }, { width: 120 }],
  },
  {
    name: 'Stock',
    rows: [
      {
        cells: [{ value: 'Item Name' }, { value: 'Available Count' }],
      },
      {
        cells: [{ value: 'Sports Shoes' }, { value: '30' }],
      },
      {
        cells: [{ value: 'Formal Shoes' }, { value: '25' }],
      },
      {
        cells: [{ value: 'Flip-Flops & Slippers' }, { value: '40' }],
      },
      {
        cells: [{ value: 'Running Shoes' }, { value: '25' }],
      },
    ],
    columns: [{ width: 160 }, { width: 120 }],
  },
];
var spreadsheet = new ej.spreadsheet.Spreadsheet({
  sheets: sheet,
  allowOpen: true,
  openUrl: 'https://services.syncfusion.com/js/production/api/spreadsheet/open',
  allowSave: true,
  saveUrl: 'https://services.syncfusion.com/js/production/api/spreadsheet/save',
  created: function () {
    spreadsheet.cellFormat({ fontWeight: 'bold' }, 'A1:C1');
  }
});
spreadsheet.appendTo('#spreadsheet');
<!DOCTYPE html>
<html lang="en">

<head>
  <title>EJ2 SpreadSheet</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="description" content="Typescript UI Controls">
  <meta name="author" content="Syncfusion">
  <link rel="shortcut icon" href="resources/favicon.ico">
  <link href="https://cdn.syncfusion.com/ej2/29.1.33/material.css" rel="stylesheet" />
  <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-grids/styles/material.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-spreadsheet/styles/material.css" rel="stylesheet">
  <link href="styles.css" rel="stylesheet">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/core-js/2.4.1/shim.min.js"></script>
  <script src="https://cdn.syncfusion.com/ej2/29.1.33/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
  <div id="container">
    <div id="spreadsheet"></div>
  </div>
  <script>
    var ele = document.getElementById('container');
    if (ele) {
      ele.style.visibility = "visible";
    }   
  </script>
  <script src="index.js" type="text/javascript"></script>
</body>

</html>

Limitations

  • When importing the document with notes, the formatting of the content in the notes will not be available. Similarly, while adding notes, we cannot apply formatting to them.
  • The style and appearance of the dialog box for the notes, including size, color, border, and other elements, cannot be directly changed.
  • Exporting the workbook along with notes is not supported in file formats such as Comma Separated Values (.csv), Excel Macro-Enabled Workbook (.xlsm), Excel Binary Workbook (.xlsb), and PDF Document (.pdf).
  • Notes added outside the used ranges of the worksheet will not be included in the exported document.

Notes in Vue Spreadsheet component

7 Jan 202522 minutes to read

The Notes feature is used to insert comments, provide feedback, suggest changes, or leave remarks on specific cells while reviewing documents in the Spreadsheet. You can enable or disable the notes functionality using the enableNotes property, which defaults to true.

When opening the Excel document with notes in the Spreadsheet, they will be displayed in the control. The cells containing notes will be indicated with a red colored triangle at the top-right corner. Hovering the mouse over these cells will display the content of the notes.

Spreadsheet showing a note

In the below example, you can add, edit, save, and delete notes.

<template>
  <ejs-spreadsheet ref="spreadsheet" :created="created" :allowOpen="true" :openUrl="openUrl" :allowSave="true" :saveUrl="saveUrl">
    <e-sheets>
      <e-sheet name="Price Details">
        <e-ranges>
          <e-range :dataSource="dataSource"></e-range>
        </e-ranges>
        <e-columns>
          <e-column :width="width1"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width3"></e-column>
        </e-columns>
      </e-sheet>
    </e-sheets>
  </ejs-spreadsheet>
</template>

<script setup>
import { ref } from "vue";
import { SpreadsheetComponent as EjsSpreadsheet, ColumnsDirective as EColumns, ColumnDirective as EColumn, RowsDirective as ERows, RowDirective as ERow, CellsDirective as ECells, CellDirective as ECell, RangesDirective as ERanges, RangeDirective as ERange, SheetsDirective as ESheets, SheetDirective as ESheet } from "@syncfusion/ej2-vue-spreadsheet";
import { data } from './data.js';

const spreadsheet = ref(null);
const dataSource = data;
const openUrl = 'https://services.syncfusion.com/vue/production/api/spreadsheet/open';
const saveUrl = 'https://services.syncfusion.com/vue/production/api/spreadsheet/save';
const width1 = 180;
const width2 = 130;
const width3 = 120;

const created = function () {
  spreadsheet.value.cellFormat({ fontWeight: 'bold', textAlign: 'center' }, 'A1:H1');
  spreadsheet.value.cellFormat({ verticalAlign: 'middle' }, 'A1:H11');
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-grids/styles/material.css';
@import "../node_modules/@syncfusion/ej2-vue-spreadsheet/styles/material.css";
</style>
<template>
  <ejs-spreadsheet ref="spreadsheet" :created="created" :allowOpen="true" :openUrl="openUrl" :allowSave="true" :saveUrl="saveUrl">
    <e-sheets>
      <e-sheet name="Price Details">
        <e-ranges>
          <e-range :dataSource="dataSource"></e-range>
        </e-ranges>
        <e-columns>
          <e-column :width="width1"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width3"></e-column>
        </e-columns>
      </e-sheet>
    </e-sheets>
  </ejs-spreadsheet>
</template>

<script>
import { SpreadsheetComponent, ColumnsDirective, ColumnDirective, RowsDirective, RowDirective, CellsDirective, CellDirective, RangesDirective, RangeDirective, SheetsDirective, SheetDirective } from "@syncfusion/ej2-vue-spreadsheet";
import { data } from './data.js';

export default {
  name: "App",
  components: {
    "ejs-spreadsheet": SpreadsheetComponent,
    "e-sheets": SheetsDirective,
    "e-sheet": SheetDirective,
    "e-ranges": RangesDirective,
    "e-range": RangeDirective,
    "e-columns": ColumnsDirective,
    "e-column": ColumnDirective,
    "e-rows": RowsDirective,
    "e-row": RowDirective,
    "e-cells": CellsDirective,
    "e-cell": CellDirective
  },
  data: () => {
    return {
      dataSource: data,
      openUrl: 'https://services.syncfusion.com/vue/production/api/spreadsheet/open',
      saveUrl: 'https://services.syncfusion.com/vue/production/api/spreadsheet/save',
      width1: 180,
      width2: 130,
      width3: 120
    }
  },
  methods: {
    created: function () {
      let spreadsheet = this.$refs.spreadsheet;
      spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center' }, 'A1:H1');
      spreadsheet.cellFormat({ verticalAlign: 'middle' }, 'A1:H11');
    }
  }
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-grids/styles/material.css';
@import "../node_modules/@syncfusion/ej2-vue-spreadsheet/styles/material.css";
</style>

Adding a note

In the active worksheet, you can add a note in the following ways:

  • To add a note, right-click the cell to open the context menu and choose the “Add Note” option from the context menu. This will open a dialog box to add the content as a note.
  • You can also use the Shift + F2 keyboard shortcut to add a note to the desired cell. A dialog box will be opened to add the content as a note.
  • After entering the content in the dialog box, you can either click on other cells or press the Esc button on the keyboard to automatically save the note in the cell and close the dialog box.

Adding a note in Spreadsheet

Editing a note

In the active worksheet, you can modify the content of existing notes in the document.

  • To edit a note, right-click on the desired cell containing the note, which will open the context menu.
  • Select the “Edit Note” option from the context menu.
  • You can also use the Shift + F2 keyboard shortcut to edit the note of the desired cell. A dialog box will be opened to edit the note.
  • After editing the content in the dialog box, you can either click on other cells or press the Esc button on the keyboard to automatically save the note in the cell and close the dialog box.

Editing a note in Spreadsheet

Deleting a note

In the active worksheet, right-click on the desired cell containing the note that you want to remove, which opens the context menu. In the context menu, select the “Delete Note” option to delete the note.

Deleting a note in Spreadsheet

Saving the document with notes

The Spreadsheet data, including notes, can be saved and exported as an Excel document by selecting File > Save As in the ribbon menu. Exporting worksheets with notes is supported in Excel file formats such as MS Excel (.xlsx) and MS Excel 97-2003 (.xls).

When exporting the Spreadsheet to file formats such as Comma Separated Values (.csv), Excel Macro-Enabled Workbook (.xlsm), Excel Binary Workbook (.xlsb), and PDF Document (.pdf), the notes will not be available.

Disabling notes

To disable the note functionality, you need to set the enableNotes property to false. After disabling, the notes in the document will not be shown when opened in the Spreadsheet. The “Add Note” option will not be shown in the context menu. The keyboard shortcuts for the note functionality will not work.

Spreadsheet with notes feature disabled

In the below example, the note functionality is disabled in the Spreadsheet.

<template>
  <ejs-spreadsheet ref="spreadsheet" :created="created" :allowOpen="true" :openUrl="openUrl" :allowSave="true" :saveUrl="saveUrl" :enableNotes="false">
    <e-sheets>
      <e-sheet name="Price Details">
        <e-ranges>
          <e-range :dataSource="dataSource"></e-range>
        </e-ranges>
        <e-columns>
          <e-column :width="width1"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width3"></e-column>
        </e-columns>
      </e-sheet>
    </e-sheets>
  </ejs-spreadsheet>
</template>

<script setup>
import { ref } from "vue";
import { SpreadsheetComponent as EjsSpreadsheet, ColumnsDirective as EColumns, ColumnDirective as EColumn, RowsDirective as ERows, RowDirective as ERow, CellsDirective as ECells, CellDirective as ECell, RangesDirective as ERanges, RangeDirective as ERange, SheetsDirective as ESheets, SheetDirective as ESheet } from "@syncfusion/ej2-vue-spreadsheet";
import { data } from './data.js';

const spreadsheet = ref(null);
const dataSource = data;
const openUrl = 'https://services.syncfusion.com/vue/production/api/spreadsheet/open';
const saveUrl = 'https://services.syncfusion.com/vue/production/api/spreadsheet/save';
const width1 = 180;
const width2 = 130;
const width3 = 120;

const created = function () {
  spreadsheet.value.cellFormat({ fontWeight: 'bold', textAlign: 'center' }, 'A1:H1');
  spreadsheet.value.cellFormat({ verticalAlign: 'middle' }, 'A1:H11');
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-grids/styles/material.css';
@import "../node_modules/@syncfusion/ej2-vue-spreadsheet/styles/material.css";
</style>
<template>
  <ejs-spreadsheet ref="spreadsheet" :created="created" :allowOpen="true" :openUrl="openUrl" :allowSave="true" :saveUrl="saveUrl" :enableNotes="false">
    <e-sheets>
      <e-sheet name="Price Details">
        <e-ranges>
          <e-range :dataSource="dataSource"></e-range>
        </e-ranges>
        <e-columns>
          <e-column :width="width1"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width3"></e-column>
        </e-columns>
      </e-sheet>
    </e-sheets>
  </ejs-spreadsheet>
</template>

<script>
import { SpreadsheetComponent, ColumnsDirective, ColumnDirective, RowsDirective, RowDirective, CellsDirective, CellDirective, RangesDirective, RangeDirective, SheetsDirective, SheetDirective } from "@syncfusion/ej2-vue-spreadsheet";
import { data } from './data.js';

export default {
  name: "App",
  components: {
    "ejs-spreadsheet": SpreadsheetComponent,
    "e-sheets": SheetsDirective,
    "e-sheet": SheetDirective,
    "e-ranges": RangesDirective,
    "e-range": RangeDirective,
    "e-columns": ColumnsDirective,
    "e-column": ColumnDirective,
    "e-rows": RowsDirective,
    "e-row": RowDirective,
    "e-cells": CellsDirective,
    "e-cell": CellDirective
  },
  data: () => {
    return {
      dataSource: data,
      openUrl: 'https://services.syncfusion.com/vue/production/api/spreadsheet/open',
      saveUrl: 'https://services.syncfusion.com/vue/production/api/spreadsheet/save',
      width1: 180,
      width2: 130,
      width3: 120
    }
  },
  methods: {
    created: function () {
      let spreadsheet = this.$refs.spreadsheet;
      spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center' }, 'A1:H1');
      spreadsheet.cellFormat({ verticalAlign: 'middle' }, 'A1:H11');
    }
  }
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-grids/styles/material.css';
@import "../node_modules/@syncfusion/ej2-vue-spreadsheet/styles/material.css";
</style>

Integrating notes during initial loading and using cell data binding

The notes can be added initially when the Spreadsheet loads using cell data binding. You need to use the notes property in the cell settings to add notes to the Spreadsheet.

<template>
  <ejs-spreadsheet ref="spreadsheet" :created="created" :allowOpen="true" :openUrl="openUrl" :allowSave="true" :saveUrl="saveUrl">
    <e-sheets>
      <e-sheet name="Price Details">
        <e-ranges>
          <e-range :dataSource="dataSource"></e-range>
        </e-ranges>
        <e-rows>
          <e-row :index="rowIndex" :cells="cells" ></e-row>
          <e-row :index="rowIndex1" :cells="cells1" ></e-row>
        </e-rows>
        <e-columns>
          <e-column :width="width1"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width3"></e-column>
        </e-columns>
      </e-sheet>
    </e-sheets>
  </ejs-spreadsheet>
</template>

<script setup>
import { ref } from "vue";
import { SpreadsheetComponent as EjsSpreadsheet, ColumnsDirective as EColumns, ColumnDirective as EColumn, RowsDirective as ERows, RowDirective as ERow, CellsDirective as ECells, CellDirective as ECell, RangesDirective as ERanges, RangeDirective as ERange, SheetsDirective as ESheets, SheetDirective as ESheet } from "@syncfusion/ej2-vue-spreadsheet";
import { data } from './data.js';

const spreadsheet = ref(null);
const dataSource = data;
const openUrl = 'https://services.syncfusion.com/vue/production/api/spreadsheet/open';
const saveUrl = 'https://services.syncfusion.com/vue/production/api/spreadsheet/save';
const width1 = 180;
const width2 = 130;
const width3 = 120;
const rowIndex= 2;
const rowIndex1 = 5;
const cells = [{ index: 0, notes: 'These shoes have the highest sales in terms of quantity this month.'}];
const cells1= [{index: 0, notes: 'These shoes have been the most profitable this month.'}];
const created = function () {
  spreadsheet.value.cellFormat({ fontWeight: 'bold', textAlign: 'center' }, 'A1:H1');
  spreadsheet.value.cellFormat({ verticalAlign: 'middle' }, 'A1:H11');
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-grids/styles/material.css';
@import "../node_modules/@syncfusion/ej2-vue-spreadsheet/styles/material.css";
</style>
<template>
  <ejs-spreadsheet ref="spreadsheet" :created="created" :allowOpen="true" :openUrl="openUrl" :allowSave="true" :saveUrl="saveUrl">
    <e-sheets>
      <e-sheet name="Price Details">
        <e-ranges>
          <e-range :dataSource="dataSource"></e-range>
        </e-ranges>
        <e-rows>
          <e-row :index="rowIndex" :cells="cells" ></e-row>
          <e-row :index="rowIndex1" :cells="cells1" ></e-row>
        </e-rows>
        <e-columns>
          <e-column :width="width1"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width2"></e-column>
          <e-column :width="width3"></e-column>
        </e-columns>
      </e-sheet>
    </e-sheets>
  </ejs-spreadsheet>
</template>

<script>
import { SpreadsheetComponent, ColumnsDirective, ColumnDirective, RowsDirective, RowDirective, CellsDirective, CellDirective, RangesDirective, RangeDirective, SheetsDirective, SheetDirective } from "@syncfusion/ej2-vue-spreadsheet";
import { data } from './data.js';

export default {
  name: "App",
  components: {
    "ejs-spreadsheet": SpreadsheetComponent,
    "e-sheets": SheetsDirective,
    "e-sheet": SheetDirective,
    "e-ranges": RangesDirective,
    "e-range": RangeDirective,
    "e-columns": ColumnsDirective,
    "e-column": ColumnDirective,
    "e-rows": RowsDirective,
    "e-row": RowDirective,
    "e-cells": CellsDirective,
    "e-cell": CellDirective
  },
  data: () => {
    return {
      dataSource: data,
      openUrl: 'https://services.syncfusion.com/vue/production/api/spreadsheet/open',
      saveUrl: 'https://services.syncfusion.com/vue/production/api/spreadsheet/save',
      width1: 180,
      width2: 130,
      width3: 120,
      rowIndex: 2,
      rowIndex1: 5,
      cells: [{index: 0, notes: 'These shoes have the highest sales in terms of quantity this month.'}],
      cells1: [{index: 0, notes: 'These shoes have been the most profitable this month.'}]
    }
  },
  methods: {
    created: function () {
      let spreadsheet = this.$refs.spreadsheet;
      spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center' }, 'A1:H1');
      spreadsheet.cellFormat({ verticalAlign: 'middle' }, 'A1:H11');
    }
  }
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-dropdowns/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-navigations/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-grids/styles/material.css';
@import "../node_modules/@syncfusion/ej2-vue-spreadsheet/styles/material.css";
</style>

Limitations

  • When importing the document with notes, the formatting of the content in the notes will not be available. Similarly, while adding notes, we cannot apply formatting to them.
  • The style and appearance of the dialog box for the notes, including size, color, border, and other elements, cannot be directly changed.
  • Exporting the workbook along with notes is not supported in file formats such as Comma Separated Values (.csv), Excel Macro-Enabled Workbook (.xlsm), Excel Binary Workbook (.xlsb), and PDF Document (.pdf).
  • Notes added outside the used ranges of the worksheet will not be included in the exported document.

Notes in Angular Spreadsheet component

19 Dec 202411 minutes to read

The Notes feature is used to insert comments, provide feedback, suggest changes, or leave remarks on specific cells while reviewing documents in the Spreadsheet. You can enable or disable the notes functionality using the enableNotes property, which defaults to true.

When opening the Excel document with notes in the Spreadsheet, they will be displayed in the control. The cells containing notes will be indicated with a red colored triangle at the top-right corner. Hovering the mouse over these cells will display the content of the notes.

Spreadsheet showing a note

In the below example, you can add, edit, save, and delete notes.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { SpreadsheetAllModule } from '@syncfusion/ej2-angular-spreadsheet'

import { Component, ViewChild } from '@angular/core';
import { SpreadsheetComponent } from '@syncfusion/ej2-angular-spreadsheet';
import { dataSource } from './datasource';


@Component({
  imports: [

    SpreadsheetAllModule
  ],


  standalone: true,
  selector: 'app-container',
  template: `<ejs-spreadsheet #spreadsheet (created)="created()" [openUrl]="openUrl" allowOpen="true" [saveUrl]="saveUrl" allowSave="true" >
  <e-sheets>
      <e-sheet name="Price Details">
          <e-ranges>
              <e-range [dataSource]="data"></e-range>
          </e-ranges>
          <e-columns>
              <e-column [width]=140></e-column>
              <e-column [width]=110></e-column>
              <e-column [width]=110></e-column>
              <e-column [width]=80></e-column>
          </e-columns>
      </e-sheet>
  </e-sheets>
</ejs-spreadsheet>`,
})
export class AppComponent {
  @ViewChild('spreadsheet')
  public spreadsheetObj: SpreadsheetComponent | undefined;
  public data: object[] = dataSource;
  public openUrl = 'https://services.syncfusion.com/angular/production/api/spreadsheet/open';
  public saveUrl = 'https://services.syncfusion.com/angular/production/api/spreadsheet/save';
  created() {
    this.spreadsheetObj!.cellFormat({ fontWeight: 'bold', textAlign: 'center', verticalAlign: 'middle' }, 'A1:H1');
  };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Adding a note

In the active worksheet, you can add a note in the following ways:

  • To add a note, right-click the cell to open the context menu and choose the “Add Note” option from the context menu. This will open a dialog box to add the content as a note.
  • You can also use the Shift + F2 keyboard shortcut to add a note to the desired cell. A dialog box will be opened to add the content as a note.
  • After entering the content in the dialog box, you can either click on other cells or press the Esc button on the keyboard to automatically save the note in the cell and close the dialog box.

Adding a note in Spreadsheet

Editing a note

In the active worksheet, you can modify the content of existing notes in the document.

  • To edit a note, right-click on the desired cell containing the note, which will open the context menu.
  • Select the “Edit Note” option from the context menu.
  • You can also use the Shift + F2 keyboard shortcut to edit the note of the desired cell. A dialog box will be opened to edit the note.
  • After editing the content in the dialog box, you can either click on other cells or press the Esc button on the keyboard to automatically save the note in the cell and close the dialog box.

Editing a note in Spreadsheet

Deleting a note

In the active worksheet, right-click on the desired cell containing the note that you want to remove, which opens the context menu. In the context menu, select the “Delete Note” option to delete the note.

Deleting a note in Spreadsheet

Saving the document with notes

The Spreadsheet data, including notes, can be saved and exported as an Excel document by selecting File > Save As in the ribbon menu. Exporting worksheets with notes is supported in Excel file formats such as MS Excel (.xlsx) and MS Excel 97-2003 (.xls).

When exporting the Spreadsheet to file formats such as Comma Separated Values (.csv), Excel Macro-Enabled Workbook (.xlsm), Excel Binary Workbook (.xlsb), and PDF Document (.pdf), the notes will not be available.

Disabling notes

To disable the note functionality, you need to set the enableNotes property to false. After disabling, the notes in the document will not be shown when opened in the Spreadsheet. The “Add Note” option will not be shown in the context menu. The keyboard shortcuts for the note functionality will not work.

Spreadsheet with notes feature disabled

In the below example, the note functionality is disabled in the Spreadsheet.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { SpreadsheetAllModule } from '@syncfusion/ej2-angular-spreadsheet'

import { Component, ViewChild } from '@angular/core';
import { SpreadsheetComponent } from '@syncfusion/ej2-angular-spreadsheet';
import { dataSource } from './datasource';


@Component({
  imports: [

    SpreadsheetAllModule
  ],


  standalone: true,
  selector: 'app-container',
  template: `<ejs-spreadsheet #spreadsheet (created)="created()" [openUrl]="openUrl" allowOpen="true" [saveUrl]="saveUrl" allowSave="true" [enableNotes]="false">
  <e-sheets>
      <e-sheet name="Price Details">
          <e-ranges>
              <e-range [dataSource]="data"></e-range>
          </e-ranges>
          <e-columns>
          <e-column [width]=140></e-column>
              <e-column [width]=110></e-column>
              <e-column [width]=110></e-column>
              <e-column [width]=80></e-column>
          </e-columns>
      </e-sheet>
  </e-sheets>
</ejs-spreadsheet>`,
})
export class AppComponent {
  @ViewChild('spreadsheet')
  public spreadsheetObj: SpreadsheetComponent | undefined;
  public data: object[] = dataSource;
  public openUrl = 'https://services.syncfusion.com/angular/production/api/spreadsheet/open';
  public saveUrl = 'https://services.syncfusion.com/angular/production/api/spreadsheet/save';
  created() {
    this.spreadsheetObj!.cellFormat({ fontWeight: 'bold', textAlign: 'center', verticalAlign: 'middle' }, 'A1:H1');
  };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Integrating notes during initial loading and using cell data binding

The notes can be added initially when the Spreadsheet loads using cell data binding. You need to use the notes property in the cell settings to add notes to the Spreadsheet.

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { SpreadsheetAllModule } from '@syncfusion/ej2-angular-spreadsheet';

import { Component, ViewChild } from '@angular/core';
import { SpreadsheetComponent } from '@syncfusion/ej2-angular-spreadsheet';
import { dataSource } from './datasource';

@Component({
    imports: [SpreadsheetAllModule],

    standalone: true,
    selector: 'app-container',
    template: `<ejs-spreadsheet #spreadsheet (created)="created()" [openUrl]="openUrl" allowOpen="true" [saveUrl]="saveUrl" allowSave="true">
  <e-sheets>
      <e-sheet name="Price Details">
          <e-ranges>
              <e-range [dataSource]="data"></e-range>
          </e-ranges>
          <e-rows>
          <e-row [index]=2>
            <e-cells>
              <e-cell [index]=0 notes="These shoes have the highest sales in terms of quantity this month."></e-cell>
            </e-cells>
          </e-row>
          <e-row [index]=5>
            <e-cells>
              <e-cell [index]=0 notes="These shoes have been the most profitable this month."></e-cell>
            </e-cells>
          </e-row>
        </e-rows>
          <e-columns>
          <e-column [width]=140></e-column>
              <e-column [width]=110></e-column>
              <e-column [width]=110></e-column>
              <e-column [width]=80></e-column>
          </e-columns>
      </e-sheet>
  </e-sheets>
</ejs-spreadsheet>`,
})
export class AppComponent {
    @ViewChild('spreadsheet')
    public spreadsheetObj: SpreadsheetComponent | undefined;
    public data: object[] = dataSource;
    public openUrl =
        'https://services.syncfusion.com/angular/production/api/spreadsheet/open';
    public saveUrl =
        'https://services.syncfusion.com/angular/production/api/spreadsheet/save';
    created() {
        this.spreadsheetObj!.cellFormat({ fontWeight: 'bold', textAlign: 'center', verticalAlign: 'middle' }, 'A1:H1');
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Limitations

  • When importing the document with notes, the formatting of the content in the notes will not be available. Similarly, while adding notes, we cannot apply formatting to them.
  • The style and appearance of the dialog box for the notes, including size, color, border, and other elements, cannot be directly changed.
  • Exporting the workbook along with notes is not supported in file formats such as Comma Separated Values (.csv), Excel Macro-Enabled Workbook (.xlsm), Excel Binary Workbook (.xlsb), and PDF Document (.pdf).
  • Notes added outside the used ranges of the worksheet will not be included in the exported document.

Notes in React Spreadsheet component

18 Dec 202424 minutes to read

The Notes feature is used to insert comments, provide feedback, suggest changes, or leave remarks on specific cells while reviewing documents in the Spreadsheet. You can enable or disable the notes functionality using the enableNotes property, which defaults to true.

When opening the Excel document with notes in the Spreadsheet, they will be displayed in the control. The cells containing notes will be indicated with a red colored triangle at the top-right corner. Hovering the mouse over these cells will display the content of the notes.

Spreadsheet showing a note

In the below example, you can add, edit, save, and delete notes.

import * as React from 'react';
import { createRoot } from 'react-dom/client';
import { SpreadsheetComponent, SheetsDirective, SheetDirective, RangesDirective } from '@syncfusion/ej2-react-spreadsheet';
import { RangeDirective, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-react-spreadsheet';
import { data } from './datasource';

function App() {
    const spreadsheetRef = React.useRef(null);
    function onCreated() {
        let spreadsheet = spreadsheetRef.current;
        if (spreadsheet) {
            spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center', verticalAlign: 'middle' }, 'A1:H1');
        }
    }

    return (
        <div>
            <SpreadsheetComponent ref={spreadsheetRef} allowOpen={true} allowSave={true} openUrl='https://services.syncfusion.com/react/production/api/spreadsheet/open' saveUrl='https://services.syncfusion.com/react/production/api/spreadsheet/save' created={onCreated.bind(this)}>
                <SheetsDirective>
                    <SheetDirective name="Price Details">
                        <RangesDirective>
                            <RangeDirective dataSource={data}></RangeDirective>
                        </RangesDirective>
                        <ColumnsDirective>
                            <ColumnDirective width={130}></ColumnDirective>
                            <ColumnDirective width={92}></ColumnDirective>
                            <ColumnDirective width={96}></ColumnDirective>
                        </ColumnsDirective>
                    </SheetDirective>
                </SheetsDirective>
            </SpreadsheetComponent>
        </div>
    );
};
export default App;

const root = createRoot(document.getElementById('root'));
root.render(<App />);
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import { SpreadsheetComponent, SheetsDirective, SheetDirective, RangesDirective } from '@syncfusion/ej2-react-spreadsheet';
import { RangeDirective, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-react-spreadsheet';
import { data } from './datasource';

function App() {
    const spreadsheetRef = React.useRef<SpreadsheetComponent>(null);
    function onCreated() {
        let spreadsheet = spreadsheetRef.current;
        if (spreadsheet) {
            spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center', verticalAlign: 'middle' }, 'A1:H1');
        }
    }

    return (
        <div>
            <SpreadsheetComponent ref={spreadsheetRef} allowOpen={true} allowSave={true} openUrl='https://services.syncfusion.com/react/production/api/spreadsheet/open' saveUrl='https://services.syncfusion.com/react/production/api/spreadsheet/save' created={onCreated.bind(this)}>
                <SheetsDirective>
                    <SheetDirective name="Price Details">
                        <RangesDirective>
                            <RangeDirective dataSource={data}></RangeDirective>
                        </RangesDirective>
                        <ColumnsDirective>
                            <ColumnDirective width={130}></ColumnDirective>
                            <ColumnDirective width={92}></ColumnDirective>
                            <ColumnDirective width={96}></ColumnDirective>
                        </ColumnsDirective>
                    </SheetDirective>
                </SheetsDirective>
            </SpreadsheetComponent>
        </div>
    );
};
export default App;

const root = createRoot(document.getElementById('root')!);
root.render(<App />);

Adding a note

In the active worksheet, you can add a note in the following ways:

  • To add a note, right-click the cell to open the context menu and choose the “Add Note” option from the context menu. This will open a dialog box to add the content as a note.
  • You can also use the Shift + F2 keyboard shortcut to add a note to the desired cell. A dialog box will be opened to add the content as a note.
  • After entering the content in the dialog box, you can either click on other cells or press the Esc button on the keyboard to automatically save the note in the cell and close the dialog box.

Adding a note in Spreadsheet

Editing a note

In the active worksheet, you can modify the content of existing notes in the document.

  • To edit a note, right-click on the desired cell containing the note, which will open the context menu.
  • Select the “Edit Note” option from the context menu.
  • You can also use the Shift + F2 keyboard shortcut to edit the note of the desired cell. A dialog box will be opened to edit the note.
  • After editing the content in the dialog box, you can either click on other cells or press the Esc button on the keyboard to automatically save the note in the cell and close the dialog box.

Editing a note in Spreadsheet

Deleting a note

In the active worksheet, right-click on the desired cell containing the note that you want to remove, which opens the context menu. In the context menu, select the “Delete Note” option to delete the note.

Deleting a note in Spreadsheet

Saving the document with notes

The Spreadsheet data, including notes, can be saved and exported as an Excel document by selecting File > Save As in the ribbon menu. Exporting worksheets with notes is supported in Excel file formats such as MS Excel (.xlsx) and MS Excel 97-2003 (.xls).

When exporting the Spreadsheet to file formats such as Comma Separated Values (.csv), Excel Macro-Enabled Workbook (.xlsm), Excel Binary Workbook (.xlsb), and PDF Document (.pdf), the notes will not be available.

Disabling notes

To disable the note functionality, you need to set the enableNotes property to false. After disabling, the notes in the document will not be shown when opened in the Spreadsheet. The “Add Note” option will not be shown in the context menu. The keyboard shortcuts for the note functionality will not work.

Spreadsheet with notes feature disabled

In the below example, the note functionality is disabled in the Spreadsheet.

import * as React from 'react';
import { createRoot } from 'react-dom/client';
import { SpreadsheetComponent, SheetsDirective, SheetDirective, RangesDirective } from '@syncfusion/ej2-react-spreadsheet';
import { RangeDirective, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-react-spreadsheet';
import { data } from './datasource';

function App() {
    const spreadsheetRef = React.useRef(null);
    function onCreated() {
        let spreadsheet = spreadsheetRef.current;
        if (spreadsheet) {
            spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center', verticalAlign: 'middle' }, 'A1:H1');
        }
    }

    return (
        <div>
            <SpreadsheetComponent ref={spreadsheetRef} allowOpen={true} allowSave={true} openUrl='https://services.syncfusion.com/react/production/api/spreadsheet/open' saveUrl='https://services.syncfusion.com/react/production/api/spreadsheet/save' created={onCreated.bind(this)} enableNotes={false}>
                <SheetsDirective>
                    <SheetDirective name="Price Details">
                        <RangesDirective>
                            <RangeDirective dataSource={data}></RangeDirective>
                        </RangesDirective>
                        <ColumnsDirective>
                            <ColumnDirective width={130}></ColumnDirective>
                            <ColumnDirective width={92}></ColumnDirective>
                            <ColumnDirective width={96}></ColumnDirective>
                        </ColumnsDirective>
                    </SheetDirective>
                </SheetsDirective>
            </SpreadsheetComponent>
        </div>
    );
};
export default App;

const root = createRoot(document.getElementById('root'));
root.render(<App />);
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import { SpreadsheetComponent, SheetsDirective, SheetDirective, RangesDirective } from '@syncfusion/ej2-react-spreadsheet';
import { RangeDirective, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-react-spreadsheet';
import { data } from './datasource';

function App() {
    const spreadsheetRef = React.useRef<SpreadsheetComponent>(null);
    function onCreated() {
        let spreadsheet = spreadsheetRef.current;
        if (spreadsheet) {
            spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center', verticalAlign: 'middle' }, 'A1:H1');
        }
    }

    return (
        <div>
            <SpreadsheetComponent ref={spreadsheetRef} allowOpen={true} allowSave={true} openUrl='https://services.syncfusion.com/react/production/api/spreadsheet/open' saveUrl='https://services.syncfusion.com/react/production/api/spreadsheet/save' created={onCreated.bind(this)} enableNotes={false}>
                <SheetsDirective>
                    <SheetDirective name="Price Details">
                        <RangesDirective>
                            <RangeDirective dataSource={data}></RangeDirective>
                        </RangesDirective>
                        <ColumnsDirective>
                            <ColumnDirective width={130}></ColumnDirective>
                            <ColumnDirective width={92}></ColumnDirective>
                            <ColumnDirective width={96}></ColumnDirective>
                        </ColumnsDirective>
                    </SheetDirective>
                </SheetsDirective>
            </SpreadsheetComponent>
        </div>
    );
};
export default App;

const root = createRoot(document.getElementById('root')!);
root.render(<App />);

Integrating notes during initial loading and using cell data binding

The notes can be added initially when the Spreadsheet loads using cell data binding. You need to use the notes property in the cell settings to add notes to the Spreadsheet.

import * as React from 'react';
import { createRoot } from 'react-dom/client';
import { SpreadsheetComponent, SheetsDirective, SheetDirective, RangesDirective, RowsDirective, RowDirective } from '@syncfusion/ej2-react-spreadsheet';
import { RangeDirective, ColumnsDirective, ColumnDirective, CellsDirective, CellDirective  } from '@syncfusion/ej2-react-spreadsheet';
import { data } from './datasource';

function App() {
    const spreadsheetRef = React.useRef(null);
    function onCreated() {
        let spreadsheet = spreadsheetRef.current;
        if (spreadsheet) {
            spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center', verticalAlign: 'middle' }, 'A1:H1');
        }
    }

    return (
        <div>
            <SpreadsheetComponent ref={spreadsheetRef} allowOpen={true} allowSave={true} openUrl='https://services.syncfusion.com/react/production/api/spreadsheet/open' saveUrl='https://services.syncfusion.com/react/production/api/spreadsheet/save' created={onCreated.bind(this)}>
                <SheetsDirective>
                    <SheetDirective name="Price Details">
                        <RangesDirective>
                            <RangeDirective dataSource={data}></RangeDirective>
                        </RangesDirective>
                        <RowsDirective>
                            <RowDirective index={2}>
                                <CellsDirective>
                                    <CellDirective index={0} notes={"These shoes have the highest sales in terms of quantity this month."}></CellDirective>
                                </CellsDirective>
                            </RowDirective>
                            <RowDirective index={5}>
                                <CellsDirective>
                                    <CellDirective index={0} notes={"These shoes have been the most profitable this month."}></CellDirective>
                                </CellsDirective>
                            </RowDirective>
                        </RowsDirective>
                        <ColumnsDirective>
                            <ColumnDirective width={130}></ColumnDirective>
                            <ColumnDirective width={92}></ColumnDirective>
                            <ColumnDirective width={96}></ColumnDirective>
                        </ColumnsDirective>
                    </SheetDirective>
                </SheetsDirective>
            </SpreadsheetComponent>
        </div>
    );
};
export default App;

const root = createRoot(document.getElementById('root'));
root.render(<App />);
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import { SpreadsheetComponent, SheetsDirective, SheetDirective, RangesDirective, RowsDirective, RowDirective, CellsDirective, CellDirective, } from '@syncfusion/ej2-react-spreadsheet';
import { RangeDirective, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-react-spreadsheet';
import { data } from './datasource';

function App() {
    const spreadsheetRef = React.useRef<SpreadsheetComponent>(null);
    function onCreated() {
        let spreadsheet = spreadsheetRef.current;
        if (spreadsheet) {
            spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center', verticalAlign: 'middle' }, 'A1:H1');
        }
    }

    return (
        <div>
            <SpreadsheetComponent ref={spreadsheetRef} allowOpen={true} allowSave={true} openUrl='https://services.syncfusion.com/react/production/api/spreadsheet/open' saveUrl='https://services.syncfusion.com/react/production/api/spreadsheet/save' created={onCreated.bind(this)}>
                <SheetsDirective>
                    <SheetDirective name="Price Details">
                        <RangesDirective>
                            <RangeDirective dataSource={data}></RangeDirective>
                        </RangesDirective>
                        <RowsDirective>
                            <RowDirective index={2}>
                                <CellsDirective>
                                    <CellDirective index={0} notes={"These shoes have the highest sales in terms of quantity this month."}></CellDirective>
                                </CellsDirective>
                            </RowDirective>
                            <RowDirective index={5}>
                                <CellsDirective>
                                    <CellDirective index={0} notes={"These shoes have been the most profitable this month."}></CellDirective>
                                </CellsDirective>
                            </RowDirective>
                        </RowsDirective>
                        <ColumnsDirective>
                            <ColumnDirective width={130}></ColumnDirective>
                            <ColumnDirective width={92}></ColumnDirective>
                            <ColumnDirective width={96}></ColumnDirective>
                        </ColumnsDirective>
                    </SheetDirective>
                </SheetsDirective>
            </SpreadsheetComponent>
        </div>
    );
};
export default App;

const root = createRoot(document.getElementById('root')!);
root.render(<App />);

Limitations

  • When importing the document with notes, the formatting of the content in the notes will not be available. Similarly, while adding notes, we cannot apply formatting to them.
  • The style and appearance of the dialog box for the notes, including size, color, border, and other elements, cannot be directly changed.
  • Exporting the workbook along with notes is not supported in file formats such as Comma Separated Values (.csv), Excel Macro-Enabled Workbook (.xlsm), Excel Binary Workbook (.xlsb), and PDF Document (.pdf).
  • Notes added outside the used ranges of the worksheet will not be included in the exported document.